/* GCC */

#include <iostream>
#include <cmath>
#include <cstdio>
using namespace std;

long long longpow(long long base, long long exponent);

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    freopen("calendar.in", "r", stdin);
    freopen("calendar.out", "w", stdout);

    long long n, months[5001], amount[5001], expbase, sum = 0;
    cin >> n;
    for (long long i = 1; i <= n; ++i) cin >> months[i];

    amount[1] = 1;
    for (long long current = 2; current <= n; ++current) {
        expbase = current;
        for (long long i = 1; i < current; ++i) if (months[i] < current && months[current] >= i) --expbase;
        for (long long i = months[current]; i < current - 1; ++i) --expbase;
        //cout << expbase << '\n';
        amount[current] = longpow(expbase, 3) - longpow(expbase - 1, 3);
        //cout << amount[current] << '\n';
        if (months[current] < current) amount[current] -= (expbase - 1) * 3 + 1;
    }
    //cout << '\n';

    //for (long long i = 1; i <= n; ++i) cout << amount[i] << ' ';
    for (long long i = 1; i <= n; ++i) sum += amount[i];
    cout << sum << '\n';

    return 0;
}

long long longpow(long long base, long long exponent)
{
    long long result = 1;
    while (exponent--) result *= base;
    return result;
}
