INPUT_FILE_PATH = 'mortar.in'
OUTPUT_FILE_PATH = 'mortar.out'


def main():
    free_heights = []
    free_heights_max_x = 0

    with open(INPUT_FILE_PATH, 'r') as f:
        str_heights = f.readlines()[1].split()
        for i in str_heights:
            free_heights.append(int(i))
        free_heights.append(0)
        free_heights_max_x = len(free_heights) - 1

    jumps = 0
    current_x = 0
    while True:
        distance = jump(current_x, free_heights)
        if distance == 0:
            break
        
        current_x += distance
        jumps += 1

    with open(OUTPUT_FILE_PATH, 'w') as f:
        f.write(str(jumps))


def jump(current_x, free_heights):
    distance = 0
    while True:
        check_distance = distance + 1
        if free_heights[current_x + check_distance] <= check_distance:
            break

        distance += 1

    return distance

main()


