#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define int ll
typedef long double ld;

typedef pair<int,int> pii;
#define x first
#define y second

const int N=2e5+100;
const int PRIMES[]={2,3,5,7,11,13,17,19,23,29};
const int PRIMES_SIZE=sizeof(PRIMES)/sizeof(PRIMES[0]);

int pw[N][30];

signed main()
{
    #ifndef LOCAL
        #define name "multiply"
        freopen(name".in","r",stdin);
        freopen(name".out","w",stdout);
        ios_base::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
        #undef name
    #endif // LOCAL

    int n,k,g;
    cin>>n>>k>>g;
    if(k>25)
        k=25;
    int m=1ll<<k;
    for(int i=1;i<=n;i++)
    {
        int x;
        cin>>x;
        for(int p=0;p<PRIMES_SIZE;p++)
            while(x%PRIMES[p]==0)
                x/=PRIMES[p],
                pw[i][p]++;
    }
    multiset<int> s[PRIMES_SIZE];
    int ans=0;
    for(int l=1,r=0;l<=n;l++)
    {
        while(r<n)
        {
            bool ok=true;
            if(l<=r)
                for(int p=0;p<PRIMES_SIZE;p++)
                    if(pw[r+1][p]*m<*s[p].rbegin()||*s[p].begin()*m<pw[r+1][p])
                        ok=false;
            if(!ok)
                break;
            for(int p=0;p<PRIMES_SIZE;p++)
                s[p].insert(pw[r+1][p]);
            r++;
        }
//        cout<<l<<" -> "<<r<<"\n";
        ans+=r-l+1;
        for(int p=0;p<PRIMES_SIZE;p++)
            s[p].erase(s[p].find(pw[l][p]));
    }
    cout<<ans;
}
